## appsrc appsrc — Easy way for applications to inject buffers into a pipeline |

## Functions

void | gst_app_src_set_caps ()
GstCaps * | gst_app_src_get_caps ()
void | gst_app_src_get_latency ()
void | gst_app_src_set_latency ()
void | gst_app_src_set_size ()
gint64 | gst_app_src_get_size ()
void | gst_app_src_set_duration ()
GstClockTime | gst_app_src_get_duration ()
void | gst_app_src_set_stream_type ()
GstAppStreamType | gst_app_src_get_stream_type ()
void | gst_app_src_set_max_bytes ()
guint64 | gst_app_src_get_max_bytes ()
guint64 | gst_app_src_get_current_level_bytes ()
gboolean | gst_app_src_get_emit_signals ()
void | gst_app_src_set_emit_signals ()
void | gst_app_src_set_callbacks ()
GstFlowReturn | gst_app_src_push_buffer ()
GstFlowReturn | gst_app_src_push_sample ()
GstFlowReturn | gst_app_src_end_of_stream ()

## Types and Values

enum | GstAppStreamType
| GstAppSrcCallbacks

## Includes

    #include <gst/app/gstappsrc.h>

## Description

The appsrc element can be used by applications to insert data into a GStreamer pipeline. Unlike most GStreamer elements, appsrc provides external API functions.

appsrc can be used by linking with the libgstapp library to access the methods directly or by using the appsrc action signals.

Before operating appsrc, the caps property must be set to fixed caps describing the format of the data that will be pushed with appsrc. An exception to this is when pushing buffers with unknown caps, in which case no caps should be set. This is typically true of file-like sources that push raw byte buffers. If you don't want to explicitly set the caps, you can use gst_app_src_push_sample. This method gets the caps associated with the sample and sets them on the appsrc replacing any previously set caps (if different from sample's caps).

The main way of handing data to the appsrc element is by calling the `gst_app_src_push_buffer()` method or by emitting the push-buffer action signal. This will put the buffer onto a queue from which appsrc will read from in its streaming thread. It is important to note that data transport will not happen from the thread that performed the push-buffer call.

The "max-bytes" property controls how much data can be queued in appsrc before appsrc considers the queue full. A filled internal queue will always signal the "enough-data" signal, which signals the application that it should stop pushing data into appsrc. The "block" property will cause appsrc to block the push-buffer method until free data becomes available again.

When the internal queue is running out of data, the "need-data" signal is emitted, which signals the application that it should start pushing more data into appsrc.

In addition to the "need-data" and "enough-data" signals, appsrc can emit the "seek-data" signal when the "stream-mode" property is set to "seekable" or "random-access". The signal argument will contain the new desired position in the stream expressed in the unit set with the "format" property. After receiving the seek-data signal, the application should push-buffers from the new position.

These signals allow the application to operate the appsrc in two different ways:

The push mode, in which the application repeatedly calls the push-buffer/push-sample method with a new buffer/sample. Optionally, the queue size in the appsrc can be controlled with the enough-data and need-data signals by respectively stopping/starting the push-buffer/push-sample calls. This is a typical mode of operation for the stream-type "stream" and "seekable". Use this mode when implementing various network protocols or hardware devices.

The pull mode, in which the need-data signal triggers the next push-buffer call. This mode is typically used in the "random-access" stream-type. Use this mode for file access or other randomly accessable sources. In this mode, a buffer of exactly the amount of bytes given by the need-data signal should be pushed into appsrc.

In all modes, the size property on appsrc should contain the total stream size in bytes. Setting this property is mandatory in the random-access mode. For the stream and seekable modes, setting this property is optional but recommended.

When the application has finished pushing data into appsrc, it should call `gst_app_src_end_of_stream()` or emit the end-of-stream action signal. After this call, no more buffers can be pushed into appsrc until a flushing seek occurs or the state of the appsrc has gone through READY.

## Functions

### gst_app_src_set_caps ()

    void
    gst_app_src_set_caps (GstAppSrc *appsrc,
                          const GstCaps *caps);

Set the capabilities on the appsrc element. This function takes a copy of the caps structure. After calling this method, the source will only produce caps that match `caps` . `caps` must be fixed and the caps on the buffers must match the caps or left NULL.

#### Parameters

appsrc | a GstAppSrc |
caps | caps to set |

### gst_app_src_get_caps ()

    GstCaps *
    gst_app_src_get_caps (GstAppSrc *appsrc);

Get the configured caps on `appsrc` .

#### Parameters

appsrc | a GstAppSrc |

#### Returns

the GstCaps produced by the source. `gst_caps_unref()` after usage.

### gst_app_src_get_latency ()

    void
    gst_app_src_get_latency (GstAppSrc *appsrc,
                             guint64 *min,
                             guint64 *max);

Retrieve the min and max latencies in `min` and `max` respectively.

#### Parameters

appsrc | a GstAppSrc |
min | the min latency |
max | the min latency |

### gst_app_src_set_latency ()

    void
    gst_app_src_set_latency (GstAppSrc *appsrc,
                             guint64 min,
                             guint64 max);

Configure the `min` and `max` latency in `src` . If `min` is set to -1, the default latency calculations for pseudo-live sources will be used.

#### Parameters

appsrc | a GstAppSrc |
min | the min latency |
max | the min latency |

### gst_app_src_set_size ()

    void
    gst_app_src_set_size (GstAppSrc *appsrc,
                          gint64 size);

Set the size of the stream in bytes. A value of -1 means that the size is not known.

#### Parameters

appsrc | a GstAppSrc |
size | the size to set |

### gst_app_src_get_size ()

    gint64
    gst_app_src_get_size (GstAppSrc *appsrc);

Get the size of the stream in bytes. A value of -1 means that the size is not known.

#### Parameters

appsrc | a GstAppSrc |

#### Returns

the size of the stream previously set with `gst_app_src_set_size()`;

### gst_app_src_set_duration ()

    void
    gst_app_src_set_duration (GstAppSrc *appsrc,
                              GstClockTime duration);

Set the duration of the stream in nanoseconds. A value of GST_CLOCK_TIME_NONE means that the duration is not known.

#### Parameters

appsrc | a GstAppSrc |
duration | the duration to set |

Since: 1.10

### gst_app_src_get_duration ()

    GstClockTime
    gst_app_src_get_duration (GstAppSrc *appsrc);

Get the duration of the stream in nanoseconds. A value of GST_CLOCK_TIME_NONE means that the duration is not known.

#### Parameters

appsrc | a GstAppSrc |

#### Returns

the duration of the stream previously set with `gst_app_src_set_duration()`;

Since: 1.10

### gst_app_src_set_stream_type ()

    void
    gst_app_src_set_stream_type (GstAppSrc *appsrc,
                                 GstAppStreamType type);

Set the stream type on `appsrc` . For seekable streams, the "seek" signal must be connected to.

A stream_type stream

#### Parameters

appsrc | a GstAppSrc |
type | the new state |

### gst_app_src_get_stream_type ()

    GstAppStreamType
    gst_app_src_get_stream_type (GstAppSrc *appsrc);

Get the stream type. Control the stream type of `appsrc` with `gst_app_src_set_stream_type()`.

#### Parameters

appsrc | a GstAppSrc |

#### Returns

the stream type.

### gst_app_src_set_max_bytes ()

    void
    gst_app_src_set_max_bytes (GstAppSrc *appsrc,
                               guint64 max);

Set the maximum amount of bytes that can be queued in `appsrc` . After the maximum amount of bytes are queued, `appsrc` will emit the "enough-data" signal.

#### Parameters

appsrc | a GstAppSrc |
max | the maximum number of bytes to queue |

### gst_app_src_get_max_bytes ()

    guint64
    gst_app_src_get_max_bytes (GstAppSrc *appsrc);

Get the maximum amount of bytes that can be queued in `appsrc` .

#### Parameters

appsrc | a GstAppSrc |

#### Returns

The maximum amount of bytes that can be queued.

### gst_app_src_get_current_level_bytes ()

    guint64
    gst_app_src_get_current_level_bytes (GstAppSrc *appsrc);

Get the number of currently queued bytes inside `appsrc` .

#### Parameters

appsrc | a GstAppSrc |

#### Returns

The number of currently queued bytes.

Since: 1.2

### gst_app_src_get_emit_signals ()

    gboolean
    gst_app_src_get_emit_signals (GstAppSrc *appsrc);

Check if appsrc will emit the "new-preroll" and "new-buffer" signals.

#### Parameters

appsrc | a GstAppSrc |

#### Returns

`TRUE` if `appsrc` is emitting the "new-preroll" and "new-buffer" signals.

### gst_app_src_set_emit_signals ()

    void
    gst_app_src_set_emit_signals (GstAppSrc *appsrc,
                                  gboolean emit);

Make appsrc emit the "new-preroll" and "new-buffer" signals. This option is by default disabled because signal emission is expensive and unneeded when the application prefers to operate in pull mode.

#### Parameters

appsrc | a GstAppSrc |
emit | the new state |

### gst_app_src_set_callbacks ()

    void
    gst_app_src_set_callbacks (GstAppSrc *appsrc,
                               GstAppSrcCallbacks *callbacks,
                               gpointer user_data,
                               GDestroyNotify notify);

Set callbacks which will be executed when data is needed, enough data has been collected or when a seek should be performed. This is an alternative to using the signals, it has lower overhead and is thus less expensive, but also less flexible.

If callbacks are installed, no signals will be emitted for performance reasons.

[skip]

#### Parameters

appsrc | a GstAppSrc |
callbacks | the callbacks |
user_data | a user_data argument for the callbacks |
notify | a destroy notify function |

### gst_app_src_push_buffer ()

    GstFlowReturn
    gst_app_src_push_buffer (GstAppSrc *appsrc,
                             GstBuffer *buffer);

Adds a buffer to the queue of buffers that the appsrc element will push to its source pad. This function takes ownership of the buffer.

When the block property is TRUE, this function can block until free space becomes available in the queue.

#### Parameters

appsrc | a GstAppSrc |
buffer | a GstBuffer to push. | [transfer full]

#### Returns

GST_FLOW_OK when the buffer was successfuly queued. GST_FLOW_FLUSHING when `appsrc` is not PAUSED or PLAYING. GST_FLOW_EOS when EOS occured.

### gst_app_src_push_sample ()

    GstFlowReturn
    gst_app_src_push_sample (GstAppSrc *appsrc,
                             GstSample *sample);

Extract a buffer from the provided sample and adds it to the queue of buffers that the appsrc element will push to its source pad. Any previous caps that were set on appsrc will be replaced by the caps associated with the sample if not equal.

When the block property is TRUE, this function can block until free space becomes available in the queue.

#### Parameters

appsrc | a GstAppSrc |
sample | a GstSample from which buffer and caps may be extracted. | [transfer none]

#### Returns

GST_FLOW_OK when the buffer was successfuly queued. GST_FLOW_FLUSHING when `appsrc` is not PAUSED or PLAYING. GST_FLOW_EOS when EOS occured.

Since: 1.6

### gst_app_src_end_of_stream ()

    GstFlowReturn
    gst_app_src_end_of_stream (GstAppSrc *appsrc);

Indicates to the appsrc element that the last buffer queued in the element is the last buffer of the stream.

#### Parameters

appsrc | a GstAppSrc |

#### Returns

GST_FLOW_OK when the EOS was successfuly queued. GST_FLOW_FLUSHING when `appsrc` is not PAUSED or PLAYING.

## Types and Values

### enum GstAppStreamType

The stream type.

#### Members

GST_APP_STREAM_TYPE_STREAM | No seeking is supported in the stream, such as a live stream. |
GST_APP_STREAM_TYPE_SEEKABLE | The stream is seekable but seeking might not be very fast, such as data from a webserver. |
GST_APP_STREAM_TYPE_RANDOM_ACCESS | The stream is seekable and seeking is fast, such as in a local file. |

### GstAppSrcCallbacks

    typedef struct {
      void      (*need_data)    (GstAppSrc *src, guint length, gpointer user_data);
      void      (*enough_data)  (GstAppSrc *src, gpointer user_data);
      gboolean  (*seek_data)    (GstAppSrc *src, guint64 offset, gpointer user_data);
    } GstAppSrcCallbacks;

A set of callbacks that can be installed on the appsrc with `gst_app_src_set_callbacks()`.

#### Members

`need_data` () | Called when the appsrc needs more data. A buffer or EOS should be pushed to appsrc from this thread or another thread. `length` is just a hint and when it is set to -1, any number of bytes can be pushed into `appsrc` . |
`enough_data` () | Called when appsrc has enough data. It is recommended that the application stops calling push-buffer until the need_data callback is emitted again to avoid excessive buffer queueing. |
`seek_data` () | Called when a seek should be performed to the offset. The next push-buffer should produce buffers from the new `offset` . This callback is only called for seekable stream types. |

## See Also

GstBaseSrc, appsink